> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://developer.projectmanager.com/api-reference/hourly-rate-period/get-rate-periods/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.projectmanager.com/_mcp/server. # Get Rate Periods GET https://api.projectmanager.com/api/data/hourly-rate-periods Gets a list of all rate periods in a work space Reference: https://developer.projectmanager.com/api-reference/hourly-rate-period/get-rate-periods ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Headers - `x-integration-name` (string, optional) — The name of the calling system passed along as a header parameter ## Response ### 200 Success - `error` (AstroError, optional, nullable) — If the API call failed, this will contain information about the error that occurred. - `success` (boolean, optional) — True if the API call succeeded; false otherwise. - `hasError` (boolean, optional) — True if the API call failed. - `statusCode` (enum, optional) — The HTTP code of the response. - Allowed values: `Continue`, `SwitchingProtocols`, `Processing`, `EarlyHints`, `OK`, `Created`, `Accepted`, `NonAuthoritativeInformation`, `NoContent`, `ResetContent`, `PartialContent`, `MultiStatus`, `AlreadyReported`, `IMUsed`, `MultipleChoices`, `MovedPermanently`, `Found`, `SeeOther`, `NotModified`, `UseProxy`, `Unused`, `TemporaryRedirect`, `PermanentRedirect`, `BadRequest`, `Unauthorized`, `PaymentRequired`, `Forbidden`, `NotFound`, `MethodNotAllowed`, `NotAcceptable`, `ProxyAuthenticationRequired`, `RequestTimeout`, `Conflict`, `Gone`, `LengthRequired`, `PreconditionFailed`, `RequestEntityTooLarge`, `RequestUriTooLong`, `UnsupportedMediaType`, `RequestedRangeNotSatisfiable`, `ExpectationFailed`, `MisdirectedRequest`, `UnprocessableEntity`, `Locked`, `FailedDependency`, `UpgradeRequired`, `PreconditionRequired`, `TooManyRequests`, `RequestHeaderFieldsTooLarge`, `UnavailableForLegalReasons`, `InternalServerError`, `NotImplemented`, `BadGateway`, `ServiceUnavailable`, `GatewayTimeout`, `HttpVersionNotSupported`, `VariantAlsoNegotiates`, `InsufficientStorage`, `LoopDetected`, `NotExtended`, `NetworkAuthenticationRequired` - `data` (list of HourlyRatePeriodDto, optional) — If the API call succeeded, this will contain the results. ## Types ### AstroError Information about an error that occurred within the ProjectManager API. - `technicalError` (string, optional, nullable) — A technical description of the error that occurred. Not suitable for display to end users. - `additionalErrors` (list of string, optional, nullable) — If additional errors beyond the main error in `Message` occurred, they will be listed here as individual messages. - `validationErrors` (map from string to list of string, optional, nullable) — This contains a dictionary of validation errors. The key is the name of the field - `message` (string, optional, nullable) — A description of the error that occurred. If your application has a user interface, show this message to explain what went wrong. ### HourlyRatePeriodDto Represents a period of time for which a specific hourly rate is applicable. - `id` (string, optional) — The unique identifier of the hourly rate period. - `startDate` (string, optional, nullable) — The start date of the hourly rate period. If null this is the first period. - `finishDate` (string, optional, nullable) — The finish date of the hourly rate period. If null this is the last period. - `isCurrent` (boolean, optional) — Indicates whether the hourly rate period is the current period. - `createBy` (string, optional, nullable) — The resourceId who created the hourly rate period. - `createDate` (string, optional) — The date and time the hourly rate period was created. - `modifyBy` (string, optional, nullable) — The resourceId who last modified the hourly rate period. - `modifyDate` (string, optional, nullable) — The date and time the hourly rate period was last modified. - `values` (list of HourlyRateValueDto, optional) — A list of all the rates for the rate period ### HourlyRateValueDto Represents the value of an hourly rate for a specific period, including audit information and references to the rate definition and period. - `id` (string, optional) — Gets or sets the unique identifier for this hourly rate value entry. - `createBy` (string, optional) — Gets or sets the identifier of the user or resource who created this hourly rate value. - `createDate` (string, optional) — Gets or sets the date and time when this hourly rate value was created. - `modifyBy` (string, optional) — Gets or sets the identifier of the user or resource who last modified this hourly rate value. - `modifyDate` (string, optional) — Gets or sets the date and time when this hourly rate value was last modified. - `hourlyRateDefinitionId` (string, optional) — Gets or sets the unique identifier of the hourly rate definition to which this value belongs. - `hourlyRatePeriodId` (string, optional) — Gets or sets the unique identifier of the hourly rate period to which this value applies. - `periodStartDate` (string, optional, nullable) — Gets or sets the start date of the hourly rate period for which this value applies. This value is sourced from the associated HourlyRatePeriod. - `periodFinishDate` (string, optional, nullable) — Gets or sets the finish date of the hourly rate period for which this value applies. This value is sourced from the associated HourlyRatePeriod. - `value` (double, optional) — Gets or sets the value of the hourly rate for the specified period. ## Examples **Response** ```json { "error": { "technicalError": "string", "additionalErrors": [ "string" ], "validationErrors": {}, "message": "string" }, "success": true, "hasError": true, "statusCode": "Continue", "data": [ { "id": "string", "startDate": "2023-01-15", "finishDate": "2023-01-15", "isCurrent": true, "createBy": "string", "createDate": "2024-01-15T09:30:00Z", "modifyBy": "string", "modifyDate": "2024-01-15T09:30:00Z", "values": [ { "id": "string", "createBy": "string", "createDate": "2024-01-15T09:30:00Z", "modifyBy": "string", "modifyDate": "2024-01-15T09:30:00Z", "hourlyRateDefinitionId": "string", "hourlyRatePeriodId": "string", "periodStartDate": "2024-01-15T09:30:00Z", "periodFinishDate": "2024-01-15T09:30:00Z", "value": 1.1 } ] } ] } ``` **SDK Code** ```python import requests url = "https://api.projectmanager.com/api/data/hourly-rate-periods" headers = {"Authorization": "Bearer "} response = requests.get(url, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.projectmanager.com/api/data/hourly-rate-periods'; const options = {method: 'GET', headers: {Authorization: 'Bearer '}}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "net/http" "io" ) func main() { url := "https://api.projectmanager.com/api/data/hourly-rate-periods" req, _ := http.NewRequest("GET", url, nil) req.Header.Add("Authorization", "Bearer ") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.projectmanager.com/api/data/hourly-rate-periods") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Get.new(url) request["Authorization"] = 'Bearer ' response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.get("https://api.projectmanager.com/api/data/hourly-rate-periods") .header("Authorization", "Bearer ") .asString(); ``` ```php request('GET', 'https://api.projectmanager.com/api/data/hourly-rate-periods', [ 'headers' => [ 'Authorization' => 'Bearer ', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.projectmanager.com/api/data/hourly-rate-periods"); var request = new RestRequest(Method.GET); request.AddHeader("Authorization", "Bearer "); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Authorization": "Bearer "] let request = NSMutableURLRequest(url: NSURL(string: "https://api.projectmanager.com/api/data/hourly-rate-periods")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "GET" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```